## leveldb 1.20

=== debian/changelog ===
leveldb (1.20-2) unstable; urgency=medium

  * Don't run self-test parallel (closes: #717997).
  * Update debhelper level to 11 .
  * Update Standards-Version to 4.1.2:
    - remove libleveldb-dbg package and use the auto-generated one.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 28 Dec 2017 14:26:57 +0000

leveldb (1.20-1) unstable; urgency=low

  * New upstream release (closes: #872909):
    - builds on armhf (closes: #845783).
  * Convert markdown documentation to HTML.
  * Update Standards-Version to 4.1.0:
    - change libleveldb-dbg priority to optional.
  * Update debhelper level to 10 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 23 Sep 2017 14:30:46 +0000

leveldb (1.19-2) unstable; urgency=medium

  * Update source URL.
  * Add myself to debian/copyright .

  [ Daniel Knezevic <Daniel.Knezevic@imgtec.com> ]
  * Add the missing ReadMemoryBarrier and WriteMemoryBarrier functions for
    mips* (closes: #842032).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 06 Nov 2016 13:44:52 +0000

leveldb (1.19-1) unstable; urgency=medium

  * Imported Upstream version 1.19
  * Refresh patchset:
    - Dropped 0002-reproducible_build.patch, adopted upstream.
  * Refresh debian/copyright.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Mon, 29 Aug 2016 10:21:53 +0100
