=== debian/control ===
Source: leveldb
Section: database
Priority: optional
Maintainer: Alessio Treglia <alessio@debian.org>
Uploaders: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends:
 debhelper (>= 11),
 discount,
 libsnappy-dev (>= 1.1.3-2)
XS-Testsuite: autopkgtest
Standards-Version: 4.1.2
Homepage: https://github.com/google/leveldb
Vcs-Git: git://anonscm.debian.org/collab-maint/leveldb.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/leveldb.git

Package: libleveldb1v5
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Conflicts: libleveldb1
Replaces: libleveldb1
Description: fast key-value storage library
 LevelDB is a fast key-value storage library written at Google that
 provides an ordered mapping from string keys to string values.
 .
 Features:
  * Keys and values are arbitrary byte arrays.
  * Data is stored sorted by key.
  * Callers can provide a custom comparison function to override
    the sort order.
  * The basic operations are Put(key,value), Get(key), Delete(key).
  * Multiple changes can be made in one atomic batch.
  * Users can create a transient snapshot to get a consistent view of
    data.
  * Forward and backward iteration is supported over the data.
  * Data is automatically compressed using the Snappy compression
    library.
  * External activity (file system operations etc.) is relayed through
    a virtual interface so users can customize the operating system
    interactions.
  * Detailed documentation about how to use the library is included with
    the source code.
 .
 Limitations:
  * This is not a SQL database. It does not have a relational data model,
    it does not support SQL queries, and it has no support for indexes.
  * Only a single process (possibly multi-threaded) can access a
    particular database at a time.
  * There is no client-server support builtin to the library.
    An application that needs such support will have to wrap their own
    server around the library.
 .
 This package provides the shared library.

Package: libleveldb-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libleveldb1v5 (= ${binary:Version}),
 ${misc:Depends}
Suggests:
 leveldb-doc
Description: fast key-value storage library (development files)
 LevelDB is a fast key-value storage library written at Google that
 provides an ordered mapping from string keys to string values.
 .
 This package provides the development files.

Package: leveldb-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends}
Description: LevelDB documentation
 LevelDB is a fast key-value storage library written at Google that
 provides an ordered mapping from string keys to string values.
 .
 This package provides the developers reference for LevelDB.
