=== debian/changelog ===
leveldb (1.22-3ubuntu2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 21 Mar 2020 13:27:55 +0100

leveldb (1.22-3ubuntu1) focal; urgency=medium

  * Make autopkgtests cross-test-friendly.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 06 Dec 2019 09:34:02 -0800

leveldb (1.22-3) unstable; urgency=medium

  * Reinstate static memenv library.

  [ Helmut Grohne <helmut@subdivi.de> ]
  * Fix FTCBFS: Fix build/host confusion (closes: #933200).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 27 Jul 2019 16:36:03 +0000

leveldb (1.22-2) unstable; urgency=medium

  * Fix library installation (closes: #932917).
  * Fix {,hurd-,kfreebsd-}i386 FTBFS.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 24 Jul 2019 21:03:17 +0000

leveldb (1.22-1) unstable; urgency=medium

  * New upstream release.
  * Switch to CMake build system.
  * Don't specify parallel to debhelper.
  * Disable Vcs-* fields for now.
  * Be the primary maintainer and keep Alessio as uploader.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 22 Jul 2019 10:20:53 +0000

leveldb (1.20-2.1) sid; urgency=medium

  * Non-maintainer upload for RC bug fix.
  * Bump soname to libleveldb.so.1d and change package name to match, due to
    ABI breakage in 1.20 (closes: #877773)

 -- Julien Cristau <jcristau@debian.org>  Sun, 31 Mar 2019 12:19:04 +0200
