=== debian/control ===
--- 
+++ 
@@ -1,19 +1,21 @@
 Source: leveldb
 Section: database
 Priority: optional
-Maintainer: Alessio Treglia <alessio@debian.org>
-Uploaders: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Uploaders: Alessio Treglia <alessio@debian.org>
 Build-Depends:
  debhelper (>= 11),
+ cmake (>= 3.9),
  discount,
  libsnappy-dev (>= 1.1.3-2)
 XS-Testsuite: autopkgtest
 Standards-Version: 4.1.2
 Homepage: https://github.com/google/leveldb
-Vcs-Git: git://anonscm.debian.org/collab-maint/leveldb.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/leveldb.git
+#Vcs-Git: git://anonscm.debian.org/collab-maint/leveldb.git
+#Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/leveldb.git
 
-Package: libleveldb1v5
+Package: libleveldb1d
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -62,7 +64,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libleveldb1v5 (= ${binary:Version}),
+ libleveldb1d (= ${binary:Version}),
  ${misc:Depends}
 Suggests:
  leveldb-doc
