=== debian/changelog ===
leveldb (1.23-6) unstable; urgency=medium

  * Configure with C++17 standard (closes: #1113102, #1114166).
  * Backport upstream fix for C++23 compilation errors.
  * Remove Alessio Treglia from uploaders, thanks for all the fish!
  * Update Standards-Version to 4.7.2 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 07 Sep 2025 12:13:47 +0200

leveldb (1.23-5) unstable; urgency=medium

  * Configure with C++14 standard (closes: #1041026).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 17 Jul 2023 07:05:16 +0200

leveldb (1.23-4) unstable; urgency=medium

  [ Nobuhiro Ban <ban.nobuhiro@gmail.com> ]
  * Fence code blocks for leveldb-doc markdown files (closes: #1020283).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 19 Sep 2022 20:40:37 +0200

leveldb (1.23-3) unstable; urgency=medium

  [ Thomas Goirand <zigo@debian.org> ]
  * Re-enable RTTI support (closes: #997927).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 01 Nov 2021 19:37:05 +0100

leveldb (1.23-2) unstable; urgency=medium

  * Upload to Sid.
  * Update watch file.
  * Update Standards-Version to 4.6.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 12 Oct 2021 08:01:25 +0200

leveldb (1.23-1) experimental; urgency=medium

  * New upstream release.
  * Update patches.
  * Update packaging bits.
  * Update debhelper level to 13 .
  * Update Standards-Version to 4.5.1 .

  [ Steve Langasek <steve.langasek@ubuntu.com> ]
  * Make autopkgtests cross-test-friendly (closes: #946291).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 18 Jul 2021 07:47:38 +0200
