=== debian/control ===
--- 
+++ 
@@ -1,19 +1,18 @@
 Source: leveldb
 Section: database
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Uploaders: Alessio Treglia <alessio@debian.org>
+Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends:
- debhelper (>= 11),
- cmake (>= 3.9),
+ debhelper-compat (= 13),
+ cmake,
  discount,
- libsnappy-dev (>= 1.1.3-2)
+ libsnappy-dev,
+ libgmock-dev,
+ libbenchmark-dev
 XS-Testsuite: autopkgtest
-Standards-Version: 4.1.2
+Standards-Version: 4.7.2
+Rules-Requires-Root: no
 Homepage: https://github.com/google/leveldb
-#Vcs-Git: git://anonscm.debian.org/collab-maint/leveldb.git
-#Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/leveldb.git
 
 Package: libleveldb1d
 Section: libs
@@ -35,7 +34,7 @@
   * Data is stored sorted by key.
   * Callers can provide a custom comparison function to override
     the sort order.
-  * The basic operations are Put(key,value), Get(key), Delete(key).
+  * The basic operations are Put(key, value), Get(key), Delete(key).
   * Multiple changes can be made in one atomic batch.
   * Users can create a transient snapshot to get a consistent view of
     data.
@@ -77,6 +76,7 @@
 Package: leveldb-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends}
 Description: LevelDB documentation
