=== debian/tests/control ===
Tests: build
Depends: build-essential, libleveldb-dev, libsnappy-dev
